// (c) Max Kresch, licensed under GPLv3, 2008.
//     See LICENSE for further details.

#include <stdio.h>
#include "Dos.H"

int main() {
  Dos DL;
  Dos DT;
  Dos DSource;
  Dos DTarget;

//--- User Input --------------------------------------------------------------
  DL.fromText("tests/data/ni_300.long");
  DT.fromText("tests/data/ni_300.tran");

  DSource.fromText("tests/data/ni_300");
  DTarget.fromText("tests/data/ni_575");

  double QLTarget =  19.819991;

  double CLTarget =  0.985294;

  double QTTarget =  28.492200;

  double CTTarget =  0.972313;


//--- End User Input ----------------------------------------------------------

  DL.normalize();
  DT.normalize();
  DSource.normalize();
  DTarget.normalize();

  DL.toText("tests/DL");
  DT.toText("tests/DT");
  DSource.toText("tests/DSource");
  DTarget.toText("tests/DTarget");

  ( ((DL.rescale(CLTarget)).rebin(DL.x)).broaden(QLTarget) *\
                                       (1.0/3.0) ).toText("tests/DTarget.lf");
  ( ((DT.rescale(CTTarget)).rebin(DL.x)).broaden(QTTarget) *\
                                       (2.0/3.0) ).toText("tests/DTarget.tf");
  ( ( ((DL.rescale(CLTarget)).rebin(DL.x)).broaden(QLTarget)          +\
      ((DT.rescale(CTTarget)).rebin(DL.x)).broaden(QTTarget) * 2.0 )  *\
                                        (1.0/3.0) ).toText("tests/DTarget.f");

  int N=5;
  Vector QCE(N);
  for(int i=0;i<N;i++){ QCE.elts[i] = 0; }
  QCE.elts[0]  =  575.0; QCE.elts[1]  = QLTarget; QCE.elts[2]  = QTTarget;
                         QCE.elts[3]  = CLTarget; QCE.elts[4]  = CTTarget;

  QCE.toText("tests/QCE.f");
}
